#ifndef KVAIO_DRIVERINTERFACE_H
#define KVAIO_DRIVERINTERFACE_H

#include <qobject.h>

class QTimer;

extern "C"
{
#include <linux/sonypi.h>
#include <fcntl.h>
}

class QSocketNotifier;

class KVaioDriverInterface : public QObject
{
    Q_OBJECT
public:
    KVaioDriverInterface(QObject *parent=0);
    bool connectToDriver();
    void disconnectFromDriver();
    /** Return the current display brightness, a value between 0 and
        255. Returns -1 if the setting cannot be retrieved. */
    int brightness();
public slots:
    /** Set the display brightness. 0<= value <=255. */
    void setBrightness(int);
protected:
    bool mFnPressed;
    bool mBackPressed;
    int mFd;
    fd_set mRfds;
    QSocketNotifier *mNotifier;
    QTimer *mTimer;
    bool getBatteryStatus();
signals:
    void vaioEvent(int);
    void brightnessChanged(int);
    void batteryStatus(bool bat1Avail, int bat1Remaining, int bat1Max,
                       bool bat2Avail, int bat2Remaining, int bat2Max,
                       bool acConnected);
protected slots:
    void socketActivated(int);
    void timeout();
};

#endif // KVAIO_DRIVERINTERFACE_H
